using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Linq.SqlClient;

namespace RadioLogy
{
    public partial class frmUserType : Form
    {
        public frmUserType()
        {
            InitializeComponent();
        }

        private void UDF_GrdFill()
        {
            LSC_RadioLogyDataContext db = new LSC_RadioLogyDataContext();
            var Query = from Row in db.tblUserTypes
                        orderby Row.UserTypeID descending
                        select new
                        {
                            Row.UserTypeID,
                            Row.UsersTypeDescription
                        };
            Grd_UserType.DataSource = Query;
        }
        private void frmUserType_Load(object sender, EventArgs e)
        {
            UDF_GrdFill();
        }
        private void btnAdd_Click(object sender, EventArgs e)
        {
            Txt_UserTypeDesc.Text = String.Empty;
            btnAdd.SendToBack();
            Btn_Save.BringToFront();
            MessageBox.Show("لطفا موارد را وارد کنید");
        }



        private void Btn_Save_Click(object sender, EventArgs e)
        {
            if (Txt_UserTypeDesc.Text == "")
            {
                MessageBox.Show("ورود عنوان نوع کاربر الزامی است");
                return;
            }
            LSC_RadioLogyDataContext db = new LSC_RadioLogyDataContext();
            tblUserType userType = new tblUserType();
            userType.UsersTypeDescription = Txt_UserTypeDesc.Text.Trim();
            db.tblUserTypes.InsertOnSubmit(userType);
            db.SubmitChanges();
            UDF_GrdFill();
            btnAdd.BringToFront();
            Btn_Save.SendToBack();
            Txt_UserTypeDesc.Clear();
            MessageBox.Show("رکورد جدید درج شد");
        }

        private void Grd_UserType_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            Int32 selectedCellCount = Grd_UserType.GetCellCount(DataGridViewElementStates.Selected);
            if (selectedCellCount > 0)
            {
                if (Grd_UserType.AreAllCellsSelected(true))
                {
                    MessageBox.Show("All cells are selected", "Selected Cells");
                }
                else
                {
                    System.Text.StringBuilder sb = new System.Text.StringBuilder();
                    for (int i = 0; i < selectedCellCount; i++)
                    {
                        Txt_userTypeID.Text = Grd_UserType.Rows[int.Parse(Grd_UserType.SelectedCells[i].RowIndex.ToString())].Cells[0].Value.ToString();
                        Txt_UserTypeDesc.Text = Grd_UserType.Rows[int.Parse(Grd_UserType.SelectedCells[i].RowIndex.ToString())].Cells[1].Value.ToString();

                    }
                }
            }
        }

        private void Btn_Delete_Click(object sender, EventArgs e)
        {
            if (Txt_UserTypeDesc.Text == "")
            {
                MessageBox.Show("انتخاب نوع کاربر مورد نظر برای حذف الزامی است");
                return;
            }
            DialogResult dr = MessageBox.Show("آیا نسبت به عمل حذف اطمینان دارید" , "اخطاریه حذف" , MessageBoxButtons.OKCancel ,MessageBoxIcon.Warning );
            if (dr == DialogResult.OK)
            {
                LSC_RadioLogyDataContext db = new LSC_RadioLogyDataContext();
                tblUserType userType = db.tblUserTypes.Single(n => n.UserTypeID == int.Parse(Txt_userTypeID.Text.Trim()));
                db.tblUserTypes.DeleteOnSubmit(userType);
                db.SubmitChanges();
                Txt_UserTypeDesc.Clear();
                UDF_GrdFill();
            }
        }

        private void Btn_Edit_Click(object sender, EventArgs e)
        {
            if (Txt_userTypeID.Text == "")
            {
                MessageBox.Show("انتخاب نوع کاربر برای ویرایش الزامی است");
                return;
            }
            DialogResult dr = MessageBox.Show("آیا نسبت به عم ویرایش اطمینان دارید؟" ,"اخطاریه ویرایش" ,MessageBoxButtons.OKCancel ,MessageBoxIcon.Warning );
            if (dr == DialogResult.OK)
            {
                LSC_RadioLogyDataContext db = new LSC_RadioLogyDataContext();
                tblUserType userType = db.tblUserTypes.Single(n => n.UserTypeID == int.Parse(Txt_userTypeID.Text.Trim()));
                userType.UsersTypeDescription = Txt_UserTypeDesc.Text.Trim();
                db.SubmitChanges();
                Txt_UserTypeDesc.Clear();
                UDF_GrdFill();
            }
        }

        private void Btn_Search_Click(object sender, EventArgs e)
        {
            if (Txt_UserTypeDesc.Text == "")
            {
                MessageBox.Show("لطفا عنوان یا بخشی از عنوان نوع کاربر را وارد کنید");
                return;
            }
            LSC_RadioLogyDataContext db=new LSC_RadioLogyDataContext();
            var Query = from Row in db.tblUserTypes 
                        where SqlMethods.Like(Row.UsersTypeDescription , "%" + Txt_UserTypeDesc.Text.Trim() + "%")
                        select new
                        {
                            Row.UserTypeID,
                            Row.UsersTypeDescription 
                         };
            Grd_UserType.DataSource = Query;
            if (Query.Count() <= 0)
            {
                Txt_UserTypeDesc.Text = "";
                Btn_Refresh.BringToFront();
                Btn_Search.SendToBack();
                MessageBox.Show("رکوردی یافته نشد.");
            }
                        
        }

        private void Btn_Refresh_Click(object sender, EventArgs e)
        {
            UDF_GrdFill();
            Btn_Search.BringToFront();
            Btn_Refresh.SendToBack();
        }
    }
}